/**
 * Selection
 * Carefully selected Elementor addons bundle, for building most awesome websites
 * Exclusively on https://1.envato.market/selection
 *
 * @encoding        UTF-8
 * @version         1.12.1
 * @copyright       (C) 2018 - 2023 Merkulove ( https://merkulov.design/ ). All rights reserved.
 * @license         Envato License https://1.envato.market/KYbje
 * @contributors    Dmitry Merkulov (dmitry@merkulov.design)
 * @support         help@merkulov.design
 **/

window.addEventListener( 'DOMContentLoaded', (event) => {

    /**
     * Add to the grid third element if needed
     */
    function arrangeGrid() {

        const grids = document.querySelectorAll( '.mdp-selection-grid' );
        const isTriple = window.innerWidth > 1280;

        for ( const grid of grids ) {

            const gridItems = grid.querySelectorAll( '.mdp-selection-widget' );
            const twoInRow = ( ( gridItems.length / 3 ) - Math.floor( gridItems.length / 3 ) ) > 0.65;

            if ( isTriple && twoInRow ) {

                const emptyDiv = document.createElement( 'div' );
                emptyDiv.className = 'mdp-selection-widget mdp-empty';

                grid.appendChild( emptyDiv );

            }

        }

    }

    /** Init function */
    arrangeGrid();

});