/**
 * Selection
 * Carefully selected Elementor addons bundle, for building most awesome websites
 * Exclusively on https://1.envato.market/selection
 *
 * @encoding        UTF-8
 * @version         1.12.1
 * @copyright       (C) 2018 - 2023 Merkulove ( https://merkulov.design/ ). All rights reserved.
 * @license         Envato License https://1.envato.market/KYbje
 * @contributors    Dmitry Merkulov (dmitry@merkulov.design)
 * @support         help@merkulov.design
 **/

window.addEventListener( 'DOMContentLoaded', ( e ) => {

    /**
     * Copy template shortcode to the clipboard
     * @param e
     */
    function copyTemplateShortcode( e ) {

        const button = e.target;

        if ( ! button.classList.contains( 'selection-shortcode-copy' ) ) { return; }
        e.preventDefault();

        const shortcode = button.nextElementSibling.value;
        navigator.clipboard.writeText( shortcode ).then(function() {
            /* clipboard successfully set */

            // Replace icon
            eiconChanger( button, 'eicon-code-bold', 'eicon-check', 2500 );


        }, function() {
            /* clipboard write failed */

            eiconChanger( button, 'eicon-code-bold', 'eicon-editor-close', 500 )

        });

    }

    /**
     * Elementor icons changer
     * @param $element
     * @param from
     * @param to
     * @param revertTime
     */
    function eiconChanger( $element, from, to, revertTime = 0 ) {

        $element.classList.remove( from );
        $element.classList.add( to );
        $element.disabled = true;

        if ( revertTime > 0 ) {

            setTimeout( () => {

                $element.classList.remove( to );
                $element.classList.add( from );
                $element.disabled = false;

            }, revertTime );

        }

    }

    document.body.addEventListener( 'click', copyTemplateShortcode );

} );