/**
 * Testimoner for Elementor
 * Customizable testimonial for Elementor editor
 * Exclusively on https://1.envato.market/testimoner-elementor
 *
 * @encoding        UTF-8
 * @version         1.12.1
 * @copyright       (C) 2018 - 2023 Merkulove ( https://merkulov.design/ ). All rights reserved.
 * @license         Envato License https://1.envato.market/KYbje
 * @contributors    Nemirovskiy Vitaliy (nemirovskiyvitaliy@gmail.com), Cherviakov Vlad (vladchervjakov@gmail.com), Dmitry Merkulov (dmitry@merkulov.design)
 * @support         help@merkulov.design
 **/

"use strict";

/**
 * Mdp testimoner main object
 * @type {{testimoner: mdpTestimoner.testimoner, addTestimoner: mdpTestimoner.addTestimoner}}
 */

const mdpTestimoner = {

    testimoner: function ( wrapperName ) {
        const $ratingStars = document.querySelectorAll( `.${wrapperName} .mdp-testimoner-elementor-rating--star` );
        const ratingCount = +document.querySelector( `.${wrapperName}` ).dataset.rating;

        if ( $ratingStars.length > 0 ) {
            for ( let i = 0; i < ratingCount; i++ ) {
                $ratingStars[i].classList.add('mdp-testimoner-elementor-rating--star-active');
            }
        }


    },

    addTestimoner: function () {

        const testimonerBox = document.querySelectorAll( '.mdp-testimoner-elementor-box' );

        for ( let i = 0; i < testimonerBox.length; i++ ) {
            testimonerBox[i].classList.add( 'mdp-testimoner-elementor-box-' + i );
            this.testimoner( 'mdp-testimoner-elementor-box-' + i );
        }

    }

}

/**
 * Init for Front-End
 * @param callback
 */
document.addEventListener( 'DOMContentLoaded', mdpTestimoner.addTestimoner.bind( mdpTestimoner ) );